Subject: Re: [PATCH v2 2/3] net_sched: Add accessor function for packet length for qdiscs

From: Patrick McHardy <[email-masked]>
Date: Sat, 26 Jul 2008 15:21:42 +0200

David Miller wrote:
> From: Jarek Poplawski <[email-masked]>
> Date: Fri, 25 Jul 2008 11:37:57 +0000
> 
>> On Fri, Jul 25, 2008 at 03:57:12AM -0700, David Miller wrote:
>>> Even TCP depends upon that NET_XMIT_* return value having some real
>>> meaning, remember the HTB bug we tracked down last week? :-)
>> Do you mean this bug you've forgotten to fix yet?
> 
> I have not forgotten, it is in TODO list. :)
> 
> I want to also inquire with Patrick about whether he is going to
> perform the audit in this area which he said he wanted to do :-)

I'm a bit backlogged, so it will take some more time.

> Well, we have patch which fixes the problem for the tester, so we
> could just merge that and at least have HTB fixed.  But we know there
> are other instances of the same return value propagation problem and
> Patrick's audit is sure to turn up other similar turds...

The other problem that affects all qdiscs supporting actions is
TC_ACT_QUEUED/TC_ACT_STOLEN getting mapped to NET_XMIT_SUCCESS
even though the packet is not queued, corrupting upper qdiscs'
qlen counters.